#include <stdio.h>

#include <osmocom/core/select.h>
#include <osmocom/core/utils.h>
#include <osmocom/core/logging.h>
#include <osmocom/core/application.h>
#include <osmocom/core/fsm.h>
#include <osmocom/vty/vty.h>
#include <osmocom/vty/telnet_interface.h>

#include <osmocom/sigtran/osmo_ss7.h>
#include <osmocom/sigtran/sccp_sap.h>
#include <osmocom/sigtran/sccp_helpers.h>
#include <osmocom/sigtran/protocol/sua.h>
#include <osmocom/sigtran/protocol/m3ua.h>

#include <osmocom/gsm/protocol/gsm_08_08.h>
#include <osmocom/gsm/gsm0808.h>
#include <osmocom/gsm/gsm0808_utils.h>



/*
 * FIXME: This is stuff we need to handle the SCCP/M3UA/SCTP connection,
 * this needs to be packed somwhere. By having it global now, we also
 * only support one connection (which is ok for tests)
 */

#define SSN_BSSAP	254
#define SENDER_PC	23
#define RECEIVER_PC	1

struct osmo_sccp_user *scu = NULL;
struct osmo_sccp_instance *sccp = NULL;















/*
 * Logging sutff
 */

static const struct log_info_cat log_info_cat[] = {
};

static const struct log_info log_info = {
	.cat = log_info_cat,
	.num_cat = ARRAY_SIZE(log_info_cat),
};


static void init_logging(void)
{
	const int log_cats[] = { DLSS7, DLSUA, DLM3UA, DLSCCP, DLINP };
	unsigned int i;

	osmo_init_logging(&log_info);

	for (i = 0; i < ARRAY_SIZE(log_cats); i++)
		log_set_category_filter(osmo_stderr_target, log_cats[i], 1, LOGL_DEBUG);
}












static int testclnt_prim_cb(struct osmo_prim_hdr *oph, void *_scu)
{
	struct osmo_sccp_user *scu = _scu;
	struct osmo_scu_prim *scu_prim = (struct osmo_scu_prim *) oph;
	struct msgb *msg;

	switch (OSMO_PRIM_HDR(&scu_prim->oph)) {
	case OSMO_PRIM(OSMO_SCU_PRIM_N_CONNECT, PRIM_OP_INDICATION):
	default:
		printf("=========================================== GOT SOMETHING! ===========================================\n");
		msg = gsm0808_create_reset_ack();
		osmo_sccp_tx_unitdata(scu, &scu_prim->u.unitdata.called_addr, &scu_prim->u.unitdata.calling_addr, msg->data, msg->len);
		break;
	}



	msgb_free(msg);
	return 0;
}





int main(void)
{


	init_logging();
	osmo_ss7_init();

	sccp = osmo_sccp_simple_client(NULL, "client", SENDER_PC, OSMO_SS7_ASP_PROT_M3UA, 0, M3UA_PORT, "127.0.0.2");

	scu = osmo_sccp_user_bind(sccp, "msc", testclnt_prim_cb, SSN_BSSAP);


	while (1) {
		osmo_select_main(0);
	}

	return 0;
}
